---
title: text-rendering
slug: Web/CSS/text-rendering
tags:
  - CSS
  - CSS Property
  - Legibility
  - Ligatures
  - Precision
  - Reference
  - SVG
  - Text
  - Text Features
  - Text Rendering
  - 'recipe:css-property'
---
<div>{{CSSRef}}</div>

<p><span class="seoSummary">The <strong><code>text-rendering</code></strong> CSS property provides information to the rendering engine about what to optimize for when rendering text.</span></p>

<p>The browser makes trade-offs among speed, legibility, and geometric precision.</p>

<pre class="brush:css no-line-numbers notranslate">/* Keyword values */
text-rendering: auto;
text-rendering: optimizeSpeed;
text-rendering: optimizeLegibility;
text-rendering: geometricPrecision;

/* Global values */
text-rendering: inherit;
text-rendering: initial;
text-rendering: unset;
</pre>

<div class="note">
<p><strong>Note:</strong> The <code>text-rendering</code> property is an SVG property that is not defined in any CSS standard. However, Gecko and WebKit browsers let you apply this property to HTML and XML content on Windows, macOS, and Linux.</p>
</div>

<p>One very visible effect is <code>optimizeLegibility</code>, which enables ligatures (ff, fi, fl, etc.) in text smaller than 20px for some fonts (for example, Microsoft's <em>Calibri</em>, <em>Candara</em>, <em>Constantia</em>, and <em>Corbel</em>, or the <em>DejaVu</em> font family).</p>

<h2 id="Syntax">Syntax</h2>

<h3 id="Values">Values</h3>

<dl>
 <dt><code>auto</code></dt>
 <dd>The browser makes educated guesses about when to optimize for speed, legibility, and geometric precision while drawing text. For differences in how this value is interpreted by the browser, see the compatibility table.</dd>
 <dt><code>optimizeSpeed</code></dt>
 <dd>The browser emphasizes rendering speed over legibility and geometric precision when drawing text. It disables kerning and ligatures.</dd>
 <dt><code>optimizeLegibility</code></dt>
 <dd>The browser emphasizes legibility over rendering speed and geometric precision. This enables kerning and optional ligatures.</dd>
 <dt><code>geometricPrecision</code></dt>
 <dd>
 <p>The browser emphasizes geometric precision over rendering speed and legibility. Certain aspects of fonts — such as kerning — don't scale linearly. So this value can make text using those fonts look good.</p>

 <p>In SVG, when text is scaled up or down, browsers calculate the final size of the text (which is determined by the specified font size and the applied scale) and request a font of that computed size from the platform's font system. But if you request a font size of, say, 9 with a scale of 140%, the resulting font size of 12.6 doesn't explicitly exist in the font system, so the browser rounds the font size to 12 instead. This results in stair-step scaling of text.</p>

 <p>But the <code>geometricPrecision</code> property — when fully supported by the rendering engine — lets you scale your text fluidly. For large scale factors, you might see less-than-beautiful text rendering, but the size is what you would expect—neither rounded up nor down to the nearest font size supported by Windows or Linux.</p>

 <p class="note"><strong>Note</strong>: WebKit precisely applies the specified value, but Gecko treats the value the same as <code>optimizeLegibility</code>.</p>
 </dd>
</dl>

<h2 id="Formal_definition">Formal definition</h2>

<p>{{CSSInfo}}</p>

<h2 id="Formal_syntax">Formal syntax</h2>

<pre class="syntaxbox notranslate">{{csssyntax}}</pre>

<h2 id="Examples">Examples</h2>

<h3 id="Automatic_application_of_optimizeLegibility">Automatic application of optimizeLegibility</h3>

<p>This demonstrates how <code>optimizeLegibility</code> is used by browsers automatically when the <code>font-size</code> is smaller than <code>20px</code>.</p>

<h4 id="HTML">HTML</h4>

<pre class="brush: html notranslate">&lt;p class="small"&gt;LYoWAT - ff fi fl ffl&lt;/p&gt;
&lt;p class="big"&gt;LYoWAT - ff fi fl ffl&lt;/p&gt;</pre>

<h4 id="CSS">CSS</h4>

<pre class="brush: css notranslate">.small { font: 19.9px "Constantia", "Times New Roman", "Georgia", "Palatino", serif; }
.big   { font: 20px "Constantia", "Times New Roman", "Georgia", "Palatino", serif; }</pre>

<h4 id="Result">Result</h4>

<p>{{ EmbedLiveSample('Automatic_application_of_optimizeLegibility') }}</p>

<h3 id="optimizeSpeed_vs_optimizeLegibility">optimizeSpeed vs optimizeLegibility</h3>

<p>This example shows the difference between the appearance of <code>optimizeSpeed</code> and <code>optimizeLegibility</code> (in your browser; other browsers may vary).</p>

<h4 id="HTML_2">HTML</h4>

<pre class="brush: html notranslate">&lt;p class="speed"&gt;LYoWAT - ff fi fl ffl&lt;/p&gt;
&lt;p class="legibility"&gt;LYoWAT - ff fi fl ffl&lt;/p&gt;</pre>

<h4 id="CSS_2">CSS</h4>

<pre class="brush: css notranslate">p { font: 1.5em "Constantia", "Times New Roman", "Georgia", "Palatino", serif }

.speed       { text-rendering: optimizeSpeed; }
.legibility  { text-rendering: optimizeLegibility; }</pre>

<h4 id="Result_2">Result</h4>

<p>{{ EmbedLiveSample('optimizeSpeed_vs_optimizeLegibility') }}</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName('SVG2', 'painting.html#TextRenderingProperty', 'text-rendering')}}</td>
   <td>{{Spec2('SVG2')}}</td>
   <td>No change</td>
  </tr>
  <tr>
   <td>{{SpecName('SVG1.1', 'painting.html#TextRenderingProperty', 'text-rendering')}}</td>
   <td>{{Spec2('SVG1.1')}}</td>
   <td>Initial definition</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("css.properties.text-rendering")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web/API/Canvas_API/Tutorial/Drawing_text">Drawing text in a <code>&lt;canvas&gt;</code></a></li>
 <li><a href="/en-US/docs/Web/CSS/CSS_Text_Decoration">CSS Text Decoration</a> CSS module</li>
 <li>Related CSS properties
  <ul>
   <li><code><a href="/en-US/docs/Web/CSS/text-decoration">text-decoration</a></code> (and its longhand properties, such as <code><a href="/en-US/docs/Web/CSS/text-decoration-line">text-decoration-line</a></code>, <code><a href="/en-US/docs/Web/CSS/text-decoration-style">text-decoration-style</a></code>, and <code><a href="/en-US/docs/Web/CSS/text-decoration-thickness">text-decoration-thickness</a></code>)</li>
   <li><code><a href="/en-US/docs/Web/CSS/text-emphasis">text-emphasis</a></code> (and its longhand properties, including <code><a href="/en-US/docs/Web/CSS/text-emphasis-color">text-emphasis-color</a></code>, <code><a href="/en-US/docs/Web/CSS/text-emphasis-position">text-emphasis-position</a></code>, and <code><a href="/en-US/docs/Web/CSS/text-emphasis-style">text-emphasis-style</a></code>)</li>
   <li><code><a href="/en-US/docs/Web/CSS/text-shadow">text-shadow</a></code></li>
   <li><code><a href="/en-US/docs/Web/CSS/text-transform">text-transform</a></code></li>
  </ul>
 </li>
 <li>The <a href="/en-US/docs/Web/SVG">SVG</a> {{SVGAttr("text-rendering")}} attribute</li>
 <li><a href="/en-US/docs/Web/SVG/Tutorial/SVG_and_CSS">SVG and CSS</a></li>
</ul>
